
#include <Button.h>

#include "SampleView.h"

// ------------------------------------------------------------
// SampleView.cpp
//

// Constructor
SampleView::SampleView( BRect frame, char *name ) :
										BView( frame, name, 
											   B_FOLLOW_ALL, B_WILL_DRAW |
											   B_PULSE_NEEDED )
{
	Red = 255;
	Green = 255;
	Blue = 255;

	// Rect to describe location of ColorButton
	BRect		ColorButtonRect((Bounds().right - 5) - BUTTON_WIDTH,
								(Bounds().bottom - 10) - BUTTON_HEIGHT,
								(Bounds().right - 5),
								(Bounds().bottom - 10));
	const char 	*ColorButtonName = "ColorButton";
	const char 	*ColorButtonLabel = "Revert to White";

	// Create a new BButton, and add it to our view hierarchy.
	ColorButton = new BButton( ColorButtonRect, ColorButtonName, 
							   ColorButtonLabel, new BMessage(COLOR_BUTTON_MESSAGE));
	AddChild(ColorButton);				   

}


// AttachedToWindow()
//
// Implemented by derived classes to complete the initialization
// of the BView when it's assigned to a window. A BView is 
// assigned to a window when it, or one of its ancestors in the 
// view hierarchy, becomes a child of a view already attached to 
// a window.
void
SampleView::AttachedToWindow()
{

}

// Draw()
//
// This function draws the updateRect portion of the view. 
// The update rectangle is stated in terms of the BView's 
// coordinate system. 
// 
// Since we don't really have much to draw here (all our children
// know how to draw themselves, like the BButton), there is no code
// here.  I left it in since it is a very important function.
void	
SampleView::Draw( BRect updateRect )
{

}

// MessageRecieved()
//
// This function is called WHENEVER a BMessage is received by the
// View.  It is up to your code to figure out what the message means,
// hence, the 'switch' statement.
void
SampleView::MessageReceived( BMessage *message )
{
	switch( message->what ){
		case COLOR_BUTTON_MESSAGE: 
			Red = 255;
			Green = 255;
			Blue = 255;
			SetViewColor( Red, Green, Blue );
			Invalidate();
			break;
	}
}


// Pulse()
//
// Declare this function if you need events to occur on regular
// time intervals.  It is executed every time the View receives a
// Pulse Message.  The view will only receive these messages
// if the B_PULSE_NEEDED flag is set in the constructor.
//
// The default interval is 500ms, you can set that with
// BWindow::SetPulseRate( int ), passing an interval in milliseconds.
void
SampleView::Pulse( void )
{
	ChangeColor();	
	SetViewColor( Red, Green, Blue );
	Invalidate();
}


// A simple function that changes the color values
void
SampleView::ChangeColor() 
{
	// First remove all Red, then Green, Then Blue.
	// Once color is Black (0,0,0), reset to White
	// (255,255,255)
	if ( Red > 0 ) {
		Red -= 5;
	}
	else if ( Green > 0 ) {
		Green -= 5;
	}
	else if ( Blue > 0 ) {
		Blue -= 5;
	}
	else {
		Red = 255;
		Green = 255;
		Blue = 255;
	}	
}
				